<template>
  <b-modal
    title="New Invoice"
    small
    :visible.sync="visible"
    @close="handleClose"
  >
    <CamundaForm v-model="formData"></CamundaForm>

    <!-- Footer -->
    <div slot="footer" class="d-flex content-end">
      <b-button @click.prevent="handleClose">Cancel</b-button>
      <b-button
        native-type="submit"
        primary
        class="ml-4x"
        @click.prevent="handleSubmit"
        >Create</b-button
      >
    </div>
  </b-modal>
</template>

<script lang="ts">
import Vue from 'vue'
import CamundaForm from '~/partials/camunda/CamundaForm.vue'

export default Vue.extend({
  name: 'AddInvoiceModal2',
  components: {
    CamundaForm,
  },
  data() {
    return {
      visible: false,
      invoice: {
        name: '',
        orderId: '',
      },
      process: null as any,
      task: null as any,
      formData: [] as any[],
    }
  },
  async created() {
    await this.loadForm()
    setTimeout(() => (this.visible = true), 1)
  },
  methods: {
    async loadForm() {
      const process = await this.$services.law.startProcessDefinition(
        'Process_TrinhLe_2',
        {
          variables: {
            invoiceType: {
              value: 'Type1',
              type: 'string',
            },
          },
        }
      )
      console.log('process', process)
      this.process = process

      const task = await this.$services.law.getTaskByProcessInstanceIdAndName(
        this.process.id,
        'Submit invoice'
      )
      console.log('task', task)
      this.task = task

      this.formData = await this.$services.law.getTaskVariables(this.task.id)
    },
    async handleSubmit() {
      const data = this.formData.reduce((a, b) => {
        a[b.key] = {
          type: b.type,
          value: b.value,
        }
        return a
      }, {})
      const rs = await this.$services.law.submitTask(this.task.id, {
        variables: data,
      })
      console.log('submitTask', rs)

      this.$emit('submit')
    },
    async handleClose() {
      const close = await this.$services.law.deleteProcessInstance(
        this.process.id
      )
      console.log('deleteProcessInstance', this.process.id, close)

      this.$emit('close')
    },
  },
})
</script>
